Donut Update in JavaScript

Using ApexCharts with JavaScript

This Donut Update example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [44, 55, 13, 33],
  chart: {
    width: 380,
    type: 'donut',
  },
  labels: ['Stocks', 'Bonds', 'Real Estate', 'Cash'],
  title: {
    text: 'Portfolio Allocation',
  },
  dataLabels: {
    enabled: false,
  },
  responsive: [
    {
      breakpoint: 480,
      options: {
        chart: {
          width: 200,
        },
        legend: {
          show: false,
        },
      },
    },
  ],
  legend: {
    position: 'right',
    offsetY: 0,
    height: 230,
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

function appendData() {
  var arr = chart.w.globals.series.slice()
  arr.push(Math.floor(Math.random() * (100 - 1 + 1)) + 1)
  return arr
}

function removeData() {
  var arr = chart.w.globals.series.slice()
  arr.pop()
  return arr
}

function randomize() {
  return chart.w.globals.series.map(function () {
    return Math.floor(Math.random() * (100 - 1 + 1)) + 1
  })
}

function reset() {
  return options.series
}

document.querySelector('#randomize').addEventListener('click', function () {
  chart.updateSeries(randomize())
})

document.querySelector('#add').addEventListener('click', function () {
  chart.updateSeries(appendData())
})

document.querySelector('#remove').addEventListener('click', function () {
  chart.updateSeries(removeData())
})

document.querySelector('#reset').addEventListener('click', function () {
  chart.updateSeries(reset())
})

Donut Update in Vue

Using ApexCharts with Vue

This Donut Update example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div>
      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="donut"
            width="380"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <div class="actions">
        <button @click="appendData">+ ADD</button>

        <button @click="removeData">- REMOVE</button>

        <button @click="randomize">RANDOMIZE</button>

        <button @click="reset">RESET</button>
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
components: {
apexchart: VueApexCharts,
},
data: function () {
return {
series: [44, 55, 13, 33],
chartOptions: {
chart: {
  width: 380,
  type: 'donut',
},
labels: ['Stocks', 'Bonds', 'Real Estate', 'Cash'],
title: {
  text: 'Portfolio Allocation'
},
dataLabels: {
  enabled: false
},
responsive: [{
  breakpoint: 480,
  options: {
    chart: {
      width: 200
    },
    legend: {
      show: false
    }
  }
}],
legend: {
  position: 'right',
  offsetY: 0,
  height: 230,
}
},
}
},
methods: {
  appendData: function () {
    var arr = this.series.slice()
    arr.push(Math.floor(Math.random() * (100 - 1 + 1)) + 1)
    this.series = arr
  },

  removeData: function () {
    if(this.series.length === 1) return
    var arr = this.series.slice()
    arr.pop()
    this.series = arr
  },

  randomize: function () {
    this.series = this.series.map(function() {
      return Math.floor(Math.random() * (100 - 1 + 1)) + 1
    })
  },

  reset: function () {
    this.series = [44, 55, 13, 33]
  }
},,
}
</script>

<style>
#chart {
  max-width: 480px;
  margin: 35px auto;
  padding: 0;
}
.actions {
  top: -10px;
  position: relative;
  z-index: 10;
  max-width: 400px;
  margin: 0 auto;
}
button {
  color: #fff;
  background: #20b2aa;
  padding: 5px 10px;
  margin: 2px;
  font-weight: bold;
  font-size: 13px;
  border-radius: 5px;
}
p {
  margin: 10px 0;
}
@media only screen and (max-width: 480px) {
  .actions {
    margin-top: 0;
    left: 0;
  }
}
</style>

import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [44, 55, 13, 33],
    options: {
      chart: {
        width: 380,
        type: 'donut',
      },
      labels: ['Stocks', 'Bonds', 'Real Estate', 'Cash'],
      title: {
        text: 'Portfolio Allocation',
      },
      dataLabels: {
        enabled: false,
      },
      responsive: [
        {
          breakpoint: 480,
          options: {
            chart: {
              width: 200,
            },
            legend: {
              show: false,
            },
          },
        },
      ],
      legend: {
        position: 'right',
        offsetY: 0,
        height: 230,
      },
    },
  })

  function appendData() {
    var arr = state.series.slice()
    arr.push(Math.floor(Math.random() * (100 - 1 + 1)) + 1)

    setState({
      ...state,
      series: arr,
    })
  }

  function removeData() {
    if (state.series.length === 1) return

    var arr = state.series.slice()
    arr.pop()

    setState({
      ...state,
      series: arr,
    })
  }

  function randomize() {
    setState({
      ...state,
      series: state.series.map(function () {
        return Math.floor(Math.random() * (100 - 1 + 1)) + 1
      }),
    })
  }

  function reset() {
    setState({
      ...state,
      series: [44, 55, 13, 33],
    })
  }

  return (
    <div>
      <div>
        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="donut"
              width={380}
            />
          </div>
        </div>

        <div className="actions">
          <button onClick={() => appendData()}>+ ADD</button>
          &nbsp;
          <button onClick={() => removeData()}>- REMOVE</button>
          &nbsp;
          <button onClick={() => randomize()}>RANDOMIZE</button>
          &nbsp;
          <button onClick={() => reset()}>RESET</button>
        </div>
      </div>
    </div>
  )
}

export default ApexChart

Donut Update in Angular

Using ApexCharts with Angular

This Donut Update example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private currentSeries: any[] = [44, 55, 13, 33];

  private appendData = (): any => {
          var arr = this.currentSeries.slice()
          arr.push(Math.floor(Math.random() * (100 - 1 + 1)) + 1)
          return arr
        };

  private removeData = (): any => {
          var arr = this.currentSeries.slice()
          arr.pop()
          return arr
        };

  private randomize = (): any => {
          return this.currentSeries.map(function () {
            return Math.floor(Math.random() * (100 - 1 + 1)) + 1
          })
        };

  private reset = (): any => {
          return this.chartOptions.series
        };

  public chartOptions: Partial<ChartOptions> = {
          series: [44, 55, 13, 33],
          chart: {
            width: 380,
            type: 'donut',
          },
          labels: ['Stocks', 'Bonds', 'Real Estate', 'Cash'],
          title: {
            text: 'Portfolio Allocation',
          },
          dataLabels: {
            enabled: false,
          },
          responsive: [
            {
              breakpoint: 480,
              options: {
                chart: {
                  width: 200,
                },
                legend: {
                  show: false,
                },
              },
            },
          ],
          legend: {
            position: 'right',
            offsetY: 0,
            height: 230,
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');

    document.querySelector('#randomize')?.addEventListener('click', () => {
            this.chart.updateSeries(this.currentSeries = (this.randomize()))
          })
    document.querySelector('#add')?.addEventListener('click', () => {
            this.chart.updateSeries(this.currentSeries = (this.appendData()))
          })
    document.querySelector('#remove')?.addEventListener('click', () => {
            this.chart.updateSeries(this.currentSeries = (this.removeData()))
          })
    document.querySelector('#reset')?.addEventListener('click', () => {
            this.chart.updateSeries(this.currentSeries = (this.reset()))
          })
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}